set long 4096
set echo on
set pagesize 100
set linesize 100
set serveroutput on
pause
set autotrace on
select * from dept;
select * from dept;
ALTER SYSTEM FLUSH BUFFER_CACHE;
ALTER SYSTEM FLUSH SHARED_POOL;
pause
select * from dept;
ALTER SYSTEM FLUSH BUFFER_CACHE;
ALTER SYSTEM FLUSH SHARED_POOL;
select * from dept;
set autotrace off;
pause
select deptno,ename,sal
    from emp
    order by deptno,sal;
select avg(sal) avg
      ,median(sal) median
      ,deptno
   from emp
   group by deptno;
pause
drop table myemp;
drop table myemplog;
create table myemp
(
  EMPNO                  NUMBER(4) not null
 ,ENAME                  VARCHAR2(10)
 ,JOB                    VARCHAR2(9)
 ,MGR                    NUMBER(4)
 ,HIREDATE               DATE
 ,SAL                    NUMBER(5,2)
 ,COMM                   NUMBER(5,2)
 ,DEPTNO                 NUMBER(2)
);
EXECUTE DBMS_ERRLOG.CREATE_ERROR_LOG('myemp', 'myemplog');
INSERT into MYEMP
 select * from emp
    log errors
       into myemplog ('Oracle rocks!')
       REJECT LIMIT UNLIMITED;
select * from emp;
select * from myemp;
select * from myemplog;
pause
@c:\ora11g10gdiffs\login.sql
connect scott
connect john
pause
drop table myjunktable;
create table myjunktable
as select * from emp;
select count(*) from myjunktable;
drop table myjunktable;
select count(*) from myjunktable;
show recyclebin;
flashback table myjunktable to before drop;
select count(*) from myjunktable;
drop table myjunktable purge;
purge recyclebin;
pause
select prod_id
     , substr(prod_name,1,20) prod_name
     , substr(prod_desc,1,30) prod_desc
   from sh.products
   where prod_name like ('E%')
      or prod_name like ('P%')
   order by prod_id;
select prod_id
     , substr(prod_name,1,20) prod_name
     , substr(prod_desc,1,30) prod_desc
   from sh.products
   where regexp_like (prod_name,'^E|^P')
   order by prod_id;
pause
drop view sales_view;
CREATE OR REPLACE VIEW sales_view AS
	SELECT  country_name country,
		prod_name prod,
		calendar_year year,
		SUM(amount_sold) sale,
		COUNT(amount_sold) cnt
		FROM sh.sales
                    ,sh.times
                    ,sh.customers
                    ,sh.countries
                    ,sh.products
	WHERE sales.time_id = times.time_id 
          AND sales.prod_id = products.prod_id 
          AND sales.cust_id = customers.cust_id 
          AND customers.country_id = countries.country_id 
          AND ( customers.country_id = 52779 
             OR customers.country_id = 52776 ) 
          AND ( prod_name = 'Standard Mouse' 
             OR prod_name = 'Mouse Pad' )
	GROUP BY country_name,prod_name,calendar_year;
select max(year) from sales_view;
SELECT SUBSTR(country,1,20) country, SUBSTR(prod,1,15) prod, year, sales
 FROM sales_view
 MODEL RETURN UPDATED ROWS
  PARTITION BY (country)
  DIMENSION BY (prod, year)
  MEASURES (sale sales)
  RULES (
   sales['Mouse Pad', 2002] = sales['Mouse Pad', 2001] +
        sales['Mouse Pad', 2000])
 ORDER BY country, prod, year;
SELECT SUBSTR(country,1,20) country, SUBSTR(prod,1,15) prod, year, sales
 FROM sales_view
 where prod = 'Mouse Pad'
 MODEL RETURN ALL ROWS
  PARTITION BY (country)
  DIMENSION BY (prod, year)
  MEASURES (sale sales)
  RULES (
   sales['Mouse Pad', 2002] = sales['Mouse Pad', 2001] +
        sales['Mouse Pad', 2000])
 ORDER BY country, prod, year;
 pause
 commit;
 update bonus set sal = 1000 where ename = 'ALLEN';
 update emp set sal = 4000 where ename = 'JONES';
 select e.ename,e.sal,b.ename,b.sal
  from emp e join bonus b
    on e.ename = b.ename;
 merge
     into bonus
     using emp
     on ( bonus.ename = emp.ename )
     when matched
     then  update -- only one update match allowed!
            set bonus.sal = emp.sal,
                bonus.comm = emp.comm
           delete
            where bonus.sal > 3999
     when not matched
         then insert
            (ename,job,sal,comm)
           values
            (emp.ename,emp.job,emp.sal,emp.comm);
 select e.ename,e.sal,b.ename,b.sal
  from emp e join bonus b
    on e.ename = b.ename;
rollback;
pause
select count(*) nbr_rows
  from sh.sales;
select count(*) * 10 nbr_rows
  from sh.sales sample(10);
select count(*) * 10 nbr_rows
  from sh.sales sample(10);
select count(*) * 10 nbr_rows
  from sh.sales sample(10) seed(1);
select count(*) * 10 nbr_rows
  from sh.sales sample(10) seed(1);
pause
begin
  $if $$hoohah $then
     dbms_output.put_line('hoo hah!');
  $end
  dbms_output.put_line('testing');
end;
/
pause
alter session set plsql_ccflags = 'hoohah:true';
begin
  $if $$hoohah $then
     dbms_output.put_line('hoo hah!');
  $end
  dbms_output.put_line('testing');
end;
/
alter session set plsql_ccflags = 'hoohah:null';
begin
  $if $$hoohah $then
     dbms_output.put_line('hoo hah!');
  $end
  dbms_output.put_line('testing');
end;
/
pause Warning!
pause Warning! -- Old assumptions may cause surprises!!
-- Warning! Warning! Potential Application Breakage!
--
--   ORDER BY has always been the only way
--      to guarantee output sequence
--   Some developers have been "sloppy" and
--      assumed that since some statements
--      seemed to be solved via sort that
--      an additional sort was not needed...
--
--   Oracle 10g DOES NOT always return rows
--      in the same way earlier releases did
--
--   The two simple statements below would have
--      shown sorted output in earlier releases
--      without an ORDER BY you might get surprised!
pause
select distinct ename from emp;
select deptno,count(*) from emp group by deptno;
--
pause Oracle 11g starts here
pause Virtual Columns
--
DROP TABLE EMPTESTV;
--
CREATE TABLE EMPTESTV AS SELECT * FROM EMP;
--
ALTER TABLE EMPTESTV ADD (income AS (NVL(SAL,0) + NVL(COMM,0)));
--
SELECT * FROM EMPTESTV;
--
DROP TABLE NEWEMP;
--
CREATE TABLE NEWEMP
       (EMPNO NUMBER(4) NOT NULL,
        ENAME VARCHAR2(10),
        JOB VARCHAR2(9),
        MGR NUMBER(4),
        HIREDATE DATE,
        SAL NUMBER(7, 2),
        COMM NUMBER(7, 2),
       	INCOME NUMBER(9,2) 
           GENERATED ALWAYS 
           AS (NVL("SAL",0)+NVL("COMM",0)) VIRTUAL VISIBLE,
        DEPTNO NUMBER(2));
INSERT INTO NEWEMP (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8369, 'SMITH',  'CLERK',     7902,
        TO_DATE('17-DEC-2000', 'DD-MON-YYYY'),  8000, NULL, 20);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8499, 'ALLEN',  'SALESMAN',  7698,
        TO_DATE('20-FEB-2001', 'DD-MON-YYYY'), 16000,  3000, 30);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8521, 'WARD',   'SALESMAN',  7698,
        TO_DATE('22-FEB-2001', 'DD-MON-YYYY'), 12500,  5000, 30);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8566, 'JONES',  'MANAGER',   7839,
        TO_DATE('2-APR-2001', 'DD-MON-YYYY'),  29750, NULL, 20);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8654, 'MARTIN', 'SALESMAN',  7698,
        TO_DATE('28-SEP-2001', 'DD-MON-YYYY'), 12500, 14000, 30);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8698, 'BLAKE',  'MANAGER',   7839,
        TO_DATE('1-MAY-2001', 'DD-MON-YYYY'),  28500, NULL, 30);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8782, 'CLARK',  'MANAGER',   7839,
        TO_DATE('9-JUN-2001', 'DD-MON-YYYY'),  24500, NULL, 10);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8788, 'SCOTT',  'ANALYST',   7566,
        TO_DATE('09-DEC-2002', 'DD-MON-YYYY'), 30000, NULL, 20);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8839, 'KING',   'PRESIDENT', NULL,
        TO_DATE('17-NOV-2001', 'DD-MON-YYYY'), 50000, NULL, 10);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8844, 'TURNER', 'SALESMAN',  7698,
        TO_DATE('8-SEP-2001', 'DD-MON-YYYY'),  15000,    0, 30);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8876, 'ADAMS',  'CLERK',     7788,
        TO_DATE('12-JAN-2003', 'DD-MON-YYYY'), 11000, NULL, 20);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8900, 'JAMES',  'CLERK',     7698,
        TO_DATE('3-DEC-2001', 'DD-MON-YYYY'),   9500, NULL, 30);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8902, 'FORD',   'ANALYST',   7566,
        TO_DATE('3-DEC-2001', 'DD-MON-YYYY'),  30000, NULL, 20);
INSERT INTO NEWEMP  (EMPNO,ENAME,JOB,MGR,HIREDATE,SAL,COMM,DEPTNO) VALUES
        (8934, 'MILLER', 'CLERK',     7782,
        TO_DATE('23-JAN-2002', 'DD-MON-YYYY'), 13000, NULL, 10);
--
COMMIT;
select ename,sal,comm,income
  from newemp;
pause
select * from
  (select job,deptno,income from newemp) query1
    pivot (avg(income)
    for deptno in (10 AS ACCOUNTING, 20 AS RESEARCH, 30 AS SALES))
    order by job;
pause
drop table pivot_emp_table;
create table pivot_emp_table as
select * from
  (select job,deptno,income from newemp) query1
    pivot (avg(income)
    for deptno in (10 AS ACCOUNTING, 20 AS RESEARCH, 30 AS SALES))
    order by job;
select * from pivot_emp_table;
select * from pivot_emp_table
  unpivot include nulls
    (avgpay for dept in (ACCOUNTING,RESEARCH,SALES))
order by job;
pause
declare
--  mytestvar pls_integer := 2147483645;
  mytestvar simple_integer := 2147483645;
begin
  dbms_output.put_line('Value of mytestvar starting ' || mytestvar);
  loop
     mytestvar := mytestvar + 1;
     dbms_output.put_line('Value of mytestvar is now ' || mytestvar);
     exit when mytestvar < 10;
  end loop;
  dbms_output.put_line('Value of mytestvar at end is ' || mytestvar);
end;
/
pause
declare
  mytestvar pls_integer := 2147483645;
--  mytestvar simple_integer := 2147483645;
begin
  dbms_output.put_line('Value of mytestvar starting ' || mytestvar);
  loop
     mytestvar := mytestvar + 1;
     dbms_output.put_line('Value of mytestvar is now ' || mytestvar);
     exit when mytestvar < 10;
  end loop;
  dbms_output.put_line('Value of mytestvar at end is ' || mytestvar);
end;
/
pause
--
drop sequence ora11seq;
--
create sequence ora11seq
  start with 10 increment by 2;
--
declare
   myvalue pls_integer := 0;
begin
   dbms_output.put_line('Starting now...');
   for loopctr in 1..5 loop
       myvalue := ora11seq.nextval;
   end loop;
   dbms_output.put_line('Value of myvalue is ' || to_char(myvalue));
end;
/
pause
declare
   ctr pls_integer := 6;
begin
   dbms_output.put_line('Counting down to blastoff!');
   for loopctr in reverse 1 .. ctr loop
     if loopctr in (4,2) then
         continue;
     end if;
     dbms_output.put_line(to_char(loopctr));
   end loop;
   dbms_output.put_line('Blast Off!');
end;
/
pause
-- Counts occurrences 
--    of letter 'L'
--    starting in position 1
--    in a case-insenstive way 
select ename
      ,regexp_count(ename,'l',1,'i') EnameO 
   from emp;
pause
CREATE OR REPLACE FUNCTION TEST_CALL
  ( inval1 IN NUMBER
  , inval2 IN NUMBER
  , inval3 IN NUMBER
  ) RETURN NUMBER AS
BEGIN
  RETURN inval1 + inval2 + inval3;
END TEST_CALL;
/
declare
  vara number := 23;
  varb number := 34;
  varc number := 45;
begin
  dbms_output.put_line('Pos  ' || test_call(vara,varb,varc));
  dbms_output.put_line('Name ' || test_call(inval3=>varc,inval1=>vara,inval2=>varb));
  dbms_output.put_line('Mix  ' || test_call(vara,inval3=>varc,inval2=>varb));
end;
/
